<?php
class ControllerExtensionPaymentEdfapay extends Controller
{
	private $error = array();

	public function index()
	{
		$this->load->language('extension/payment/edfapay');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('payment_edfapay', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/edfapay', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/payment/edfapay', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

		if (isset($this->request->post['payment_edfapay_total'])) {
			$data['payment_edfapay_total'] = $this->request->post['payment_edfapay_total'];
		} else {
			$data['payment_edfapay_total'] = $this->config->get('payment_edfapay_total');
		}

		if (isset($this->request->post['payment_edfapay_order_status_id'])) {
			$data['payment_edfapay_order_status_id'] = $this->request->post['payment_edfapay_order_status_id'];
		} else {
			$data['payment_edfapay_order_status_id'] = $this->config->get('payment_edfapay_order_status_id');
		}

		// order status if decline
		if (isset($this->request->post['payment_edfapay_decline_order_status_id'])) {
			$data['payment_edfapay_decline_order_status_id'] = $this->request->post['payment_edfapay_decline_order_status_id'];
		} else {
			$data['payment_edfapay_decline_order_status_id'] = $this->config->get('payment_edfapay_decline_order_status_id');
		}
		// order status if pending
		if (isset($this->request->post['payment_edfapay_pending_order_status_id'])) {
			$data['payment_edfapay_pending_order_status_id'] = $this->request->post['payment_edfapay_pending_order_status_id'];
		} else {
			$data['payment_edfapay_pending_order_status_id'] = $this->config->get('payment_edfapay_pending_order_status_id');
		}

		// order status if refunded
		if (isset($this->request->post['payment_edfapay_refunded_order_status_id'])) {
			$data['payment_edfapay_refunded_order_status_id'] = $this->request->post['payment_edfapay_refunded_order_status_id'];
		} else {
			$data['payment_edfapay_refunded_order_status_id'] = $this->config->get('payment_edfapay_refunded_order_status_id');
		}


		if (isset($this->request->post['payment_edfapay_merchant_id'])) {
			$data['payment_edfapay_merchant_id'] = $this->request->post['payment_edfapay_merchant_id'];
		} else {
			$data['payment_edfapay_merchant_id'] = $this->config->get('payment_edfapay_merchant_id');
		}

		if (isset($this->request->post['payment_edfapay_password'])) {
			$data['payment_edfapay_password'] = $this->request->post['payment_edfapay_password'];
		} else {
			$data['payment_edfapay_password'] = $this->config->get('payment_edfapay_password');
		}


		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['payment_edfapay_geo_zone_id'])) {
			$data['payment_edfapay_geo_zone_id'] = $this->request->post['payment_edfapay_geo_zone_id'];
		} else {
			$data['payment_edfapay_geo_zone_id'] = $this->config->get('payment_edfapay_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['payment_edfapay_status'])) {
			$data['payment_edfapay_status'] = $this->request->post['payment_edfapay_status'];
		} else {
			$data['payment_edfapay_status'] = $this->config->get('payment_edfapay_status');
		}

		if (isset($this->request->post['payment_edfapay_sort_order'])) {
			$data['payment_edfapay_sort_order'] = $this->request->post['payment_edfapay_sort_order'];
		} else {
			$data['payment_edfapay_sort_order'] = $this->config->get('payment_edfapay_sort_order');
		}



		// Define the transaction URL
		$data['transaction_url'] = $this->url->link('extension/payment/edfapay/transactions', 'user_token=' . $this->session->data['user_token'], true);

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/edfapay', $data));
	}

	protected function validate()
	{
		if (!$this->user->hasPermission('modify', 'extension/payment/edfapay')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

	public function transactions()
	{
		$this->load->language('extension/payment/edfapay');

		$this->document->setTitle($this->language->get('heading_title'));

		$data['breadcrumbs'] = array();

		//cancel
		$data['cancel'] = $this->url->link('extension/payment/edfapay', 'user_token=' . $this->session->data['user_token'], true);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		//SELECT `edfapay_transaction_id`, `edfapay_transaction_order_id`, `edfapay_transaction_hash`, `edfapay_transaction_status`, `edfapay_transaction_comment`, `edfapay_transaction_payment_id` FROM `oc_edfapay_transaction` WHERE 1
		$data['transactions'] = array();
		$sql = "SELECT * FROM " . DB_PREFIX . "edfapay_transaction where edfapay_transaction_status = 1 ORDER BY `edfapay_transaction_id` DESC";
		$query = $this->db->query($sql);
		// if quoery not null
		if ($query->num_rows > 0) {
			// loop through the records
			foreach ($query->rows as $row) {
				// add each record to the data array
				$data['transactions'][] = array(
					'edfapay_transaction_id' => $row['edfapay_transaction_id'],
					'edfapay_transaction_order_id' => $row['edfapay_transaction_order_id'],
					'edfapay_transaction_hash' => $row['edfapay_transaction_hash'],
					'edfapay_transaction_status' => $row['edfapay_transaction_status'],
					'edfapay_transaction_comment' => $row['edfapay_transaction_comment'],
					'edfapay_transaction_payment_id' => $row['edfapay_transaction_payment_id'],
					'refund' => $this->url->link('extension/payment/edfapay/refund', 'user_token=' . $this->session->data['user_token'] . '&edfapay_transaction_id=' . $row['edfapay_transaction_id'], true),


				);
			}
		} else {
			// if no records found, add a message to the data array
			$data['transactions'] = array();

		}



		$data['transaction_url'] = $this->url->link('extension/payment/edfapay/transaction', 'user_token=' . $this->session->data['user_token'], true);
		//load opencart header and footer
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/edfapay_transaction', $data));
	}

	public function refund()
	{
		// get edfapay_transaction_id
		if ($this->request->get['edfapay_transaction_id']) {
			$trans_id = $this->request->get['edfapay_transaction_id'];

		} else {
			exit();
		}

		// get transaction details
		$sql = "SELECT * FROM " . DB_PREFIX . "edfapay_transaction WHERE `edfapay_transaction_id` = '" . $trans_id . "'";
		$query = $this->db->query($sql);
		// if quoery not null
		if ($query->num_rows > 0) {
			// get the transaction details
			$transaction = $query->row;
			// get the order id
			$order_id = $transaction['edfapay_transaction_order_id'];
			// get the payment id
			$gwayId = $transaction['edfapay_transaction_payment_id'];
			// get the hash
			$hash = $transaction['edfapay_transaction_hash'];
			// get the status
			$status = $transaction['edfapay_transaction_status'];
			// get the comment
			$comment = $transaction['edfapay_transaction_comment'];

			// get payee amount ip from order
			$sql = "SELECT * FROM " . DB_PREFIX . "order WHERE `order_id` = '" . $order_id . "'";
			$query = $this->db->query($sql);
			// if quoery not null
			if ($query->num_rows > 0) {
				// get the order details
				$order = $query->row;
				// get the payee amount
				$payee_amount = $order['total'];
				/// 2 decimal places
				$payee_amount = number_format((float) $payee_amount, 2, '.', '');
				// get the ip
				$ip = $order['ip'];
			} else {
				exit();
			}


		} else {
			exit();
		}

		//hash Must be SHA1 of MD5 encoded string (uppercased):payment.id + amount + merchant.pass

		$hash = sha1(md5(strtoupper($gwayId . $payee_amount . $this->config->get('payment_edfapay_password'))));

		$post_data = array(
			'gwayId' => $gwayId,
			'order_id' => $order_id,
			'edfa_merchant_id' => $this->config->get('payment_edfapay_merchant_id'),
			'hash' => $hash,
			'payer_ip' => $ip,
			'amount' => $payee_amount

		);

		$curl = curl_init();

		curl_setopt_array(
			$curl,
			array(
				CURLOPT_URL => 'https://api.edfapay.com/payment/refund',
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_ENCODING => '',
				CURLOPT_MAXREDIRS => 10,
				CURLOPT_TIMEOUT => 0,
				CURLOPT_FOLLOWLOCATION => true,
				CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
				CURLOPT_CUSTOMREQUEST => 'POST',
				CURLOPT_POSTFIELDS => json_encode($post_data),
				CURLOPT_HTTPHEADER => array(
					'Content-Type: application/json'
				),
			)
		);

		$response = curl_exec($curl);

		curl_close($curl);
		// json decode response
		$json = json_decode($response, true);
		// {"statusCode":200,"responseBody":"{\"payment_id\":\"3f1f077e-68e6-11ee-bcde-3ebac0637456\",\"result\":\"accepted\"}"}
		// get the response body
		$response = $json['responseBody'];
		// response body json decode
		$response_data = json_decode($response, true);

		// if response is not null
		if (isset($response_data['result']) && $response_data['result']) {

			// if result is accepted
			if ($response_data['result'] == 'accepted') {
				// update the transaction status to 2
				$sql = "UPDATE " . DB_PREFIX . "edfapay_transaction SET `edfapay_transaction_status` = '3' WHERE `edfapay_transaction_id` = '" . $trans_id . "'";
				$query = $this->db->query($sql);
				// if query is success
				if ($query) {
					// add the comment
					$comment = $comment . ' Refunded';
					// update the comment
					$sql = "UPDATE " . DB_PREFIX . "edfapay_transaction SET `edfapay_transaction_comment` = '" . $comment . "' WHERE `edfapay_transaction_id` = '" . $trans_id . "'";
					$query = $this->db->query($sql);

					// update the order status to refunded
					$sql = "UPDATE " . DB_PREFIX . "order SET `order_status_id` = '" . $this->config->get('payment_edfapay_refund_order_status_id') . "' WHERE `order_id` = '" . $order_id . "'";
					$query = $this->db->query($sql);
					// add order history
					$sql = "INSERT INTO " . DB_PREFIX . "order_history SET `order_id` = '" . $order_id . "', `order_status_id` = '" . $this->config->get('payment_edfapay_refund_order_status_id') . "', `notify` = '0', `comment` = '" . $comment . "', `date_added` = NOW()";
					$query = $this->db->query($sql);


					// if query is success
					if ($query) {
						// redirect to transaction page
						$this->response->redirect($this->url->link('extension/payment/edfapay/transactions', 'user_token=' . $this->session->data['user_token'], true));
					} else {
						// redirect to transaction page
						// set error in session,
						$this->session->data['error'] = 'Error Refunding Transaction';

						$this->response->redirect($this->url->link('extension/payment/edfapay/transactions', 'user_token=' . $this->session->data['user_token'], true));
						exit();

					}
				} else {
					$this->session->data['error'] = 'Error Refunding Transaction';
					$this->response->redirect($this->url->link('extension/payment/edfapay/transactions', 'user_token=' . $this->session->data['user_token'], true));

					exit();

				}
			} else {
				$this->session->data['error'] = 'Error Refunding Transaction';
				$this->response->redirect($this->url->link('extension/payment/edfapay/transactions', 'user_token=' . $this->session->data['user_token'], true));

				exit();
			}

			

		}

	}

	public function install()
			{
				// CREATE TABLE `oc_edfapay_transaction` (
				// 	`edfapay_transaction_id` int NOT NULL,
				// 	`edfapay_transaction_order_id` int NOT NULL,
				// 	`edfapay_transaction_hash` varchar(255) DEFAULT NULL,
				// 	`edfapay_transaction_status` int NOT NULL DEFAULT '0',
				// 	`edfapay_transaction_comment` longtext,
				// 	`edfapay_transaction_payment_id` varchar(255) NOT NULL
				//   ) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

				//create table oc_edfapay_transaction if does not exist
				$sql = "CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "edfapay_transaction` (
					`edfapay_transaction_id` int NOT NULL AUTO_INCREMENT,
					`edfapay_transaction_order_id` int NOT NULL,
					`edfapay_transaction_hash` varchar(255) DEFAULT NULL,
					`edfapay_transaction_status` int NOT NULL DEFAULT '0',
					`edfapay_transaction_comment` longtext,
					`edfapay_transaction_payment_id` varchar(255) NOT NULL,
					PRIMARY KEY (`edfapay_transaction_id`)
				  ) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;";
				$query = $this->db->query($sql);
			
			}

}