<?php
class ControllerExtensionPaymentEdfapay extends Controller
{
    public function index()
    {
        return $this->load->view('extension/payment/edfapay');
    }

    public function confirm()
    {
        $json = array();

        $this->load->model('checkout/order');

        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $order_number = $this->session->data['order_id'];
        $order_amount = $order_info['total'];
        $order_currency = 'SAR';
        $order_description = 'Order #' . $this->session->data['order_id'];
        $password = $this->config->get('payment_edfapay_password');

        $concatenated_string = $order_number . $order_amount . $order_currency . $order_description . $password;

        $md5_hash = md5(strtoupper($concatenated_string));
        $sha1_hash = sha1($md5_hash);

        $hash_data = $sha1_hash;

        $this->session->data['hash'] = $hash_data;

        // $this->url->link('extension/payment/edfapay/return', '', true) has seo url 



        if ($order_info) {
            $post_data = array(
                'action' => 'SALE',
                'edfa_merchant_id' => $this->config->get('payment_edfapay_merchant_id'),
                'order_id' => $this->session->data['order_id'],
                'order_amount' => $order_info['total'],
                'order_currency' => 'SAR',
                'order_description' => 'Order #' . $this->session->data['order_id'],
                'req_token' => 'N',
                'payer_first_name' => $order_info['firstname'],
                'payer_last_name' => $order_info['lastname'],
                'payer_address' => $order_info['payment_address_1'],
                'payer_country' => $order_info['payment_iso_code_2'],
                'payer_city' => $order_info['payment_city'],
                'payer_zip' => $order_info['payment_postcode'],
                'payer_email' => $order_info['email'],
                'payer_phone' => $order_info['telephone'],
                'payer_ip' => $order_info['ip'],
                'term_url_3ds' => $this->url->link('extension/payment/edfapay/return'."&order_id=".$this->session->data['order_id']. "&hash=".$hash_data , '', true),
                'auth' => 'N',
                'recurring_init' => 'N',
                'hash' => $hash_data
            );
            
          
            $curl = curl_init();

            curl_setopt_array(
                $curl,
                array(
                    CURLOPT_URL => 'https://api.edfapay.com/payment/initiate',
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_ENCODING => '',
                    CURLOPT_MAXREDIRS => 10,
                    CURLOPT_TIMEOUT => 0,
                    CURLOPT_FOLLOWLOCATION => true,
                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                    CURLOPT_CUSTOMREQUEST => 'POST',
                    CURLOPT_POSTFIELDS => http_build_query($post_data),
                )
            );

            $response = curl_exec($curl);
            curl_close($curl);

            $json_decode = json_decode($response, true);

            //  var_dump($json_decode);
            //  exit();

            if ($json_decode && isset($json_decode['redirect_url'])) {
                $json['redirect'] = $json_decode['redirect_url'];
            } else {
                $json['error'] = 'Something Went Wrong';
            }

            $this->response->addHeader('Content-Type: application/json');
            $this->response->setOutput(json_encode($json));
        }
    }

    public function webhook()
    {
        
         $this->log->write(json_encode($_REQUEST));
        // exit();
        // $this->load->model('checkout/order');

        // $curl = curl_init();
        
        // if(isset($this->request->post['order_id']) && isset($this->request->post['hash'])){
        //     $hash  = explode("?", $this->request->post['hash']);
		// 	$hash = $hash[0];
        //     $order_id = $this->request->post['order_id'];
        //      $check_data = array(
        //     'order_id' =>  $order_id,
        //     'merchant_id' => $this->config->get('payment_edfapay_merchant_id'),
        //     'hash' => $hash
        //      );
            
        // }elseif(isset($this->request->get['order_id']) && isset($this->request->get['hash'])){
        //     $order_id = $this->request->get['order_id'];
        //     $hash  = explode("?", $this->request->get['hash']);
		// 	$hash = $hash[0];

        //      $check_data = array(
        //     'order_id' => $order_id,
        //     'merchant_id' => $this->config->get('payment_edfapay_merchant_id'),
        //     'hash' => $hash
        // );
        // }else{
           
            
        //      $this->session->data["error"] = "Something Went Wrong";
        // $this->response->redirect($this->url->link('checkout/checkout', '', true));
            
        
        // }


        // curl_setopt_array(
        //     $curl,
        //     array(
        //         CURLOPT_URL => 'https://api.edfapay.com/payment/status',
        //         CURLOPT_RETURNTRANSFER => true,
        //         CURLOPT_ENCODING => '',
        //         CURLOPT_MAXREDIRS => 10,
        //         CURLOPT_TIMEOUT => 0,
        //         CURLOPT_FOLLOWLOCATION => true,
        //         CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        //         CURLOPT_CUSTOMREQUEST => 'POST',
        //         CURLOPT_POSTFIELDS => json_encode($check_data),
        //         CURLOPT_HTTPHEADER => array(
        //             'Content-Type: application/json'
        //         ),
        //     )
        // );

        // $response = curl_exec($curl);

        // curl_close($curl);
        // if ($response === false) {
        //     echo 'Curl error: ' . curl_error($curl);
        //     exit();
        // }
        // $json = json_decode($response, true);
       

        // $response = $json['responseBody'];

        // $response_data = json_decode($response, true);



        // if (isset($response_data['status'])) {
        //     if ($response_data['status'] === 'decline') {
        //         $this->session->data["error"] = "Payment Failed";
        //         $this->response->redirect($this->url->link('checkout/checkout', '', true));
        //     } elseif ($response_data['status'] === 'settled') {
        //         $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('payment_edfapay_order_status_id'), "Payment Successful");
        //         $order_status = 1;
        //         $comment_data = "Payment Successful";
        //     } else {
        //         $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('payment_edfapay_pending_order_status_id'), $response_data['reason']);
        //         $order_status = 0;
        //         $comment_data = $response_data['reason'];
        //     }

        //     $sql = "INSERT INTO " . DB_PREFIX . "edfapay_transaction (
        //         `edfapay_transaction_order_id`, 
        //         `edfapay_transaction_hash`, 
        //         `edfapay_transaction_status`, 
        //         `edfapay_transaction_comment`, 
        //         `edfapay_transaction_payment_id`
        //         ) VALUES 
        //         (
        //             '" . $this->session->data['order_id'] . "',
        //              '" . $this->session->data['hash'] . "',
        //               '" . $order_status . "',
        //                '" . $comment_data . "',
        //                 '" . $response_data['payment_id'] . "'
        //                 )";
    
        //     $this->db->query($sql);
    
        //     // redirect to success page
        //     $this->session->data["success"] = "Payment Successful";
        //     $this->response->redirect($this->url->link('checkout/success', '', true));
        // }else{
        //     $this->session->data["error"] = "Something Went Wrong";
        //     $this->response->redirect($this->url->link('checkout/checkout', '', true));
        // }


        //"result":"SUCCESS","status":"SETTLED","order_id":"48","trans_id":"225b4f3c-7708-11ee-a815-3af286662672","hash":"56b78f0ce97492fef57f9947079e255a","trans_date":"2023-10-30 09:39:13","amount":"80.00","currency":"SAR","card":"512345****0008","card_expiration_date":"01\/2039"}

        $this->load->model('checkout/order');

        if(isset($this->request->post['order_id']) && isset($this->request->post['hash'])){
            if($this->request->post['status'] == 'SETTLED'){
                $this->model_checkout_order->addOrderHistory($this->request->post['order_id'], $this->config->get('payment_edfapay_order_status_id'), "Payment Successful");
                $order_status = 1;
                $comment_data = "Payment Successful";
                $order_id = $this->request->post['order_id'];
                $hash  = explode("?", $this->request->post['hash']);
                $hash = $hash[0];
                $payment_id = $this->request->post['trans_id'];


                $sql = "INSERT INTO " . DB_PREFIX . "edfapay_transaction (
                `edfapay_transaction_order_id`, 
                `edfapay_transaction_hash`, 
                `edfapay_transaction_status`, 
                `edfapay_transaction_comment`, 
                `edfapay_transaction_payment_id`
                ) VALUES 
                (
                    '" . $order_id . "',
                     '" . $hash . "',
                      '" . $order_status . "',
                       '" . $comment_data . "',
                        '" . $payment_id . "'
                        )";
    
            $this->db->query($sql);


                
            }elseif($this->request->post['status'] == 'DECLINED'){
                $this->model_checkout_order->addOrderHistory($this->request->post['order_id'], $this->config->get('payment_edfapay_decline_order_status_id'), "Payment Failed");

            }

            

        }

        if(isset($this->request->post['order_number']) && isset($this->request->post['hash'])){
            if($this->request->post['status'] == 'success'){
                $this->model_checkout_order->addOrderHistory($this->request->post['order_number'], $this->config->get('payment_edfapay_order_status_id'), "Apple Payment Successful");
                $order_status = 1;
                $comment_data = "Apple Payment Successful";
                $order_id = $this->request->post['order_number'];
                $hash  = explode("?", $this->request->post['hash']);
                $hash = $hash[0];
                $payment_id = $this->request->post['id'];


                $sql = "INSERT INTO " . DB_PREFIX . "edfapay_transaction (
                `edfapay_transaction_order_id`, 
                `edfapay_transaction_hash`, 
                `edfapay_transaction_status`, 
                `edfapay_transaction_comment`, 
                `edfapay_transaction_payment_id`
                ) VALUES 
                (
                    '" . $order_id . "',
                     '" . $hash . "',
                      '" . $order_status . "',
                       '" . $comment_data . "',
                        '" . $payment_id . "'
                        )";
    
            $this->db->query($sql);


                
            }elseif($this->request->post['status'] == 'fail'){
                $this->model_checkout_order->addOrderHistory($this->request->post['order_number'], $this->config->get('payment_edfapay_decline_order_status_id'), "Apple Payment Failed");

            }

            

        }


    }
    public function return(){

        // load header and footer
        $this->load->language('checkout/checkout');
        $this->document->setTitle($this->language->get('heading_title'));
        $data['heading_title'] = $this->language->get('heading_title');
        $data['text_checkout_option'] = $this->language->get('text_checkout_option');
        $data['text_checkout_account'] = $this->language->get('text_checkout_account');
        $data['order_id'] = $this->request->get['order_id'];

        $data['header'] = $this->load->controller('common/header');
        $data['footer'] = $this->load->controller('common/footer');




        $this->response->setOutput($this->load->view('extension/payment/edfapay_return', $data));

      

    }

    public function checkorder(){
        $this->load->model('checkout/order');

        $order_id = $this->request->get['order_id'];
        $json = array();

        // chcek if order is already paid
           $order_info = $this->model_checkout_order->getOrder($order_id);
           if($order_info){
           if($order_info['order_status_id'] == $this->config->get('payment_edfapay_order_status_id')){
            $json['status'] = 'success';
            $json['message'] = 'Payment Successful';
            $this->session->data["success"] = "Payment Successful";
            $json['redirect'] = $this->url->link('checkout/success', '', true);
            
           
           }elseif($order_info['order_status_id'] == 0 ){
            $json['status'] = 'waiting';
            $json['message'] = 'Waiting For Complete Payment';
            // $json['redirect'] = $this->url->link('checkout/checkout', '', true);
          
           }else{
            $json['status'] = 'fail';
            $json['message'] = 'Payment Failed';
            $this->session->data["error"] = "Payment Failed";
            $json['redirect'] = $this->url->link('checkout/checkout', '', true);
           }
        }else{
            $json['status'] = 'fail';
            $json['message'] = 'Order Not Found';
            $this->session->data["error"] = "Order Not Found";
            $json['redirect'] = $this->url->link('checkout/checkout', '', true);
        }

           $this->response->addHeader('Content-Type: application/json');
            $this->response->setOutput(json_encode($json));

    }



}