<?php
class ControllerExtensionPaymentEdfapay extends Controller
{
    public function index()
    {
        return $this->load->view('extension/payment/edfapay');
    }

    public function confirm()
    {
        $json = array();

        $this->load->model('checkout/order');

        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $order_number = $this->session->data['order_id'];
        $order_amount = $order_info['total'];
        $order_currency = 'SAR';
        $order_description = 'Order #' . $this->session->data['order_id'];
        $password = $this->config->get('payment_edfapay_password');

        // Concatenate the data for hashing
        $concatenated_string = $order_number . $order_amount . $order_currency . $order_description . $password;

        $md5_hash = md5(strtoupper($concatenated_string));
        $sha1_hash = sha1($md5_hash);

        $hash_data = $sha1_hash;

        $this->session->data['hash'] = $hash_data;

        if ($order_info) {
            $post_data = array(
                'action' => 'SALE',
                'edfa_merchant_id' => $this->config->get('payment_edfapay_merchant_id'),
                'order_id' => $this->session->data['order_id'],
                'order_amount' => $order_info['total'],
                'order_currency' => 'SAR',
                'order_description' => 'Order #' . $this->session->data['order_id'],
                'req_token' => 'N',
                'payer_first_name' => $order_info['firstname'],
                'payer_last_name' => $order_info['lastname'],
                'payer_address' => $order_info['payment_address_1'],
                'payer_country' => $order_info['payment_iso_code_2'],
                'payer_city' => $order_info['payment_city'],
                'payer_zip' => $order_info['payment_postcode'],
                'payer_email' => $order_info['email'],
                'payer_phone' => $order_info['telephone'],
                'payer_ip' => $order_info['ip'],
                'term_url_3ds' => $this->url->link('extension/payment/edfapay/return', '', true),
                'auth' => 'N',
                'recurring_init' => 'N',
                'hash' => $hash_data
            );

            $curl = curl_init();

            curl_setopt_array(
                $curl,
                array(
                    CURLOPT_URL => 'https://api.edfapay.com/payment/initiate',
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_ENCODING => '',
                    CURLOPT_MAXREDIRS => 10,
                    CURLOPT_TIMEOUT => 0,
                    CURLOPT_FOLLOWLOCATION => true,
                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                    CURLOPT_CUSTOMREQUEST => 'POST',
                    CURLOPT_POSTFIELDS => http_build_query($post_data),
                    // Use http_build_query to format POST data
                )
            );

            $response = curl_exec($curl);
            curl_close($curl);

            $json_decode = json_decode($response, true);

            // var_dump($json_decode);

            if ($json_decode && isset($json_decode['redirect_url'])) {
                $json['redirect'] = $json_decode['redirect_url'];
            } else {
                $json['error'] = 'Something Went Wrong';
            }

            $this->response->addHeader('Content-Type: application/json');
            $this->response->setOutput(json_encode($json));
        }
    }

    public function return ()
    {
        $this->load->model('checkout/order');

        $curl = curl_init();

        $check_data = array(
            'order_id' => $this->session->data['order_id'],
            'merchant_id' => $this->config->get('payment_edfapay_merchant_id'),
            'hash' => $this->session->data['hash']
        );

        // var_dump($check_data);

        // $curl = curl_init();

        curl_setopt_array(
            $curl,
            array(
                CURLOPT_URL => 'https://api.edfapay.com/payment/status',
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => json_encode($check_data),
                CURLOPT_HTTPHEADER => array(
                    'Content-Type: application/json'
                ),
            )
        );

        $response = curl_exec($curl);

        curl_close($curl);
        if ($response === false) {
            echo 'Curl error: ' . curl_error($curl);
            exit();
        }
        $json = json_decode($response, true);

        $response = $json['responseBody'];

        $response_data = json_decode($response, true);


        // $response_data = json_decode($response, true);
        // var_dump($response_data);
        // exit();

        //		//SELECT `edfapay_transaction_id`, `edfapay_transaction_order_id`, `edfapay_transaction_hash`, `edfapay_transaction_status`, `edfapay_transaction_comment`, `edfapay_transaction_payment_id` FROM `oc_edfapay_transaction` WHERE 1

        // insert into transaction table


        if ($response_data['status']) {
            if ($response_data['status'] === 'decline') {
                $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('payment_edfapay_decline_order_status_id'), $response_data['reason']);
                $order_status = 2;
                $comment_data = $response_data['reason'];
            } elseif ($response_data['status'] === 'settled') {
                $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('payment_edfapay_order_status_id'), "Payment Successful");
                $order_status = 1;
                $comment_data = "Payment Successful";
            } else {
                $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('payment_edfapay_pending_order_status_id'), $response_data['reason']);
                $order_status = 0;
                $comment_data = $response_data['reason'];
            }
        }

        $sql = "INSERT INTO " . DB_PREFIX . "edfapay_transaction (
            `edfapay_transaction_order_id`, 
            `edfapay_transaction_hash`, 
            `edfapay_transaction_status`, 
            `edfapay_transaction_comment`, 
            `edfapay_transaction_payment_id`
            ) VALUES 
            (
                '" . $this->session->data['order_id'] . "',
                 '" . $this->session->data['hash'] . "',
                  '" . $order_status . "',
                   '" . $comment_data . "',
                    '" . $response_data['payment_id'] . "'
                    )";

        $this->db->query($sql);

        // redirect to success page
        $this->session->data["success"] = "Payment Successful";
        $this->response->redirect($this->url->link('checkout/success', '', true));
    }


    // public function transactions() {
    //     $this->load->language('extension/payment/edfapay');

    //     $this->document->setTitle($this->language->get('heading_title'));

    //     // Load necessary variables here

    //     $data['breadcrumbs'] = array();

    //     $data['breadcrumbs'][] = array(
    //       'text' => $this->language->get('text_home'),
    //       'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
    //     );

    //     $data['breadcrumbs'][] = array(
    //       'text' => $this->language->get('text_extension'),
    //       'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
    //     );


    //     $data['transaction_url'] = $this->url->link('extension/payment/edfapay/transaction', 'user_token=' . $this->session->data['user_token'], true);

    //     $this->response->setOutput($this->load->view('extension/payment/edfapay_transaction', $data));
    //   }




}